# flix

**flix** (*flight + X*) — making an open source ESP32-based quadcopter from scratch.

## Features

* Very simple and clear source code.
* Acro and Stabilized flight using remote control.
* Precise simulation using Gazebo.
* In-RAM logging.
* Command line interface through USB port.
* Wi-Fi support.
* ESCs with reverse mode support.
* *Textbook and videos for students on writing a flight controller\*.*
* *MAVLink support\*.*
* *Position control and autonomous flights using external camera\**.

*\* — planned.*

## Version 0

### Components

|Component|Type|Image|Quantity|
|-|-|-|-|
|ESP32 Mini|Microcontroller board|<img src="docs/img/esp32.jpg" width=180>|1|
|GY-91|IMU+barometer board|<img src="docs/img/gy-91.jpg" width=180>|1|
|K100|Quadcopter frame|<img src="docs/img/frame.jpg" width=180>|1|
|8520 3.7V brushed motor|Motor|<img src="docs/img/motor.jpeg" width=180>|4|
|Hubsan 55 mm| Propeller|<img src="docs/img/prop.jpg" width=180>|4|
|2.7A 1S Dual Way Micro Brush ESC|Motor ESC|<img src="docs/img/esc.jpg" width=180>|4|
|KINGKONG TINY X8|RC transmitter|<img src="docs/img/tx.jpg" width=180>|1|
|DF500 (SBUS)|RC receiver|<img src="docs/img/rx.jpg" width=180>|1|
||SBUS inverter|<img src="docs/img/inv.jpg" width=180>||
|3.7 Li-Po 850 MaH 60C|Battery|||
||Battery charger|<img src="docs/img/charger.jpg" width=180>||
||Wires, connectors, tape, ...||
||3D-printed frame parts||
